;;
;; Copyright (c) 2006, John P. T. Moore
;; All rights reserved.
;;
;; Redistribution and use in source and binary forms, with or without 
;; modification, are permitted provided that the following conditions are met:
;;
;; 1. Redistributions of source code must retain the above copyright notice, 
;;    this list of conditions and the following disclaimer.
;;
;; 2. Redistributions in binary form must reproduce the above copyright notice, 
;;    this list of conditions and the following disclaimer in the documentation 
;;    and/or other materials provided with the distribution.
;;
;; 3. Neither the name of the author nor the names of its contributors may be 
;;    used to endorse or promote products derived from this software 
;;    without specific prior written permission.
;;
;; THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
;; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
;; IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
;; ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
;; LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
;; CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
;; SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
;; INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
;; CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
;; ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
;; POSSIBILITY OF SUCH DAMAGE.
;;

(define constraints:lb cadr)
(define constraints:ub caddr)

(define (po:check-integer range)
  (cond
   ((or (null? range) (eq? (constraints:lb range) 'min))
    'unconstrained)
   ((>= (constraints:lb range) 0)
    (if (eq? (constraints:ub range) 'max)
	'unsigned-semi-constrained
	'unsigned-constrained))
   ((< (constraints:lb range) 0)
    (if (eq? (constraints:ub range) 'max) 
        'signed-semi-constrained
        'signed-constrained))
   (else
    (error "invalid range constraint" range))))



(define (po:check-string size)
  (cond
   ((null? size)
    'semi-constrained)
   ((= (length size) 2)
    'fixed-length)
   ((= (length size) 3)
    (if (eq? (constraints:ub size) 'max)
	'semi-constrained
	'constrained))
   (else
    (error "invalid size constraint" size))))
